- name: Download headscale
  ansible.builtin.uri:
    url: "https://github.com/juanfont/headscale/releases/download/v0.17.0-beta2/headscale_0.17.0-beta2_linux_amd64"
    dest: /usr/local/bin/headscale
    mode: a+x
    status_code: [200, 304]

- name: Create headscale group
  ansible.builtin.group:
    name: headscale
    system: true

- name: Create headscale user
  user:
    name: "headscale"
    groups: "headscale"
    system: true
    create_home: true
    home: /var/lib/headscale/
    shell: /usr/bin/nologin

- name: Creates headscale directory
  file:
    path: "{{ item }}"
    state: directory
    owner: headscale
  with_items:
    - /etc/headscale
    - /var/run/headscale/

- name: Add headscale group to admin users
  user:
    name: "{{ item.name }}"
    group: headscale
    append: true
  with_items: "{{ users }}"

- name: Create headscale db
  ansible.builtin.file:
    path: /var/lib/headscale/db.sqlite
    state: touch

- name: Upload headscale dev config
  copy:
    src: ../../config/headscale.dev.yaml
    dest: /etc/headscale/config.yaml
  when: vagrant is defined

- name: Upload headscale prod config
  copy:
    src: ../../config/headscale.prod.yaml
    dest: /etc/headscale/config.yaml
  when: vagrant is not defined

- name: Upload headscale acls
  copy:
    src: ../../config/headscale-acls.hujson
    dest: /etc/headscale/acls.hujson

- name: Upload headscale service
  copy:
    src: ../../config/headscale.service
    dest: /etc/systemd/system/headscale.service

- name: Set headscale as owner of their directories
  ansible.builtin.command: "chown -R headscale:headscale {{ item }}"
  with_items:
    - /etc/headscale/
    - /var/lib/headscale/

- name: Start headscale service
  ansible.builtin.service:
    name: headscale
    state: restarted
    enabled: true

- name: Create backbone namespace
  ansible.builtin.command: headscale namespaces create backbone

- name: Create admin namespace
  ansible.builtin.command: headscale namespaces create admin